enum SERVER{ 
ALLOCATE_TARGET=0x0a0a0a, //rgb=10 10 10  'NOT Stream values'
DEALLOCATE_TARGET=0x0b0b0b, 
COMPILE_SCRIPT=0x0c0c0c,
SHOT_BY_WEAPON = 0x0d0d0d,
PROCESS_LINE_OF_SIGHT = 0x0e0e0e,
NPC_COMMUNICATION = 0x0f0f0f,
CALL_REMOTE_FUNCTION = 0x1a1a1a
}
enum DAMAGEREPORT		//This are stream values 
{
	ASSIGN= -0x01, //we will use negative values
	UNASSIGN= -0x02,
	NPC_IS_HIT= -0x03,
	PROCESS_LINE_OF_SIGHT = -0x04,
	SHOW_FLAG_VALUES = -0x05,
	COLLISSION_REPORT = -0x06,
	CALL_PLOS_USING_AIMPOS = -0x07
}
//pid is actually not checked.
function UnSetNPCTarget( npcid, pid )
{ SetNPCTarget( npcid, pid, SERVER.DEALLOCATE_TARGET ); }

function SetNPCTarget( npcid, pid, work=SERVER.ALLOCATE_TARGET) //Tells which npc to shoot which player
//work can be SERVER.ALLOCATE_TARGET or SERVER.DEALLOCATE_TARGET
{
	local player = FindPlayer( pid );
	local npc = FindPlayer( npcid );
	local command = format( "%d", pid );
	if( typeof( work ) != "integer" )
		return;
	local work_b = work & 0x0000FF ;
	local work_g = ( work & 0x00FF00 ) >> 8 ;
	local work_r = ( work & 0xFF0000 ) >> 16 ;
	if( player && npc )
	{
		ClientMessage(command, npc, work_r, work_g, work_b);
	}
}

dofile("scripts/dmgrpts.nut"); //Damage Reports



function onPlayerJoin( player )
{
	if(!IsPlayerNPC(player.ID))
		foreach(i, npcid in LIST_OF_NPC_FOR_DAMAGEREPORT)
			ManageDamageReport( player, npcid, DAMAGEREPORT.ASSIGN );
}

function onPlayerPart( player, reason )
{
	if(IsPlayerNPC( player.ID ))
		ManageMailingList( player.ID, REMOVE_FROM_MAILING_LIST );
}
