function GetAimDir(p, q)
{
	local alpha = atan2( q.z-p.z, sqrt( pow(p.x-q.x,2)+ pow(p.y-q.y,2) ) );
	local angle = atan2( -(q.x-p.x), q.y-p.y );
	//These angles must be reduced by a small factor
	print(" old alpha is "+alpha+ " and old angle is "+angle );
	
	local camera_front = Vector( cos(alpha)*sin(-angle), cos(alpha)*cos(angle), sin(alpha) );
	local camera_up = Vector( sin(alpha) * cos(angle), sin(alpha)*sin(-angle), cos(alpha) );
	
	//If this camera_front is passed as aimpos( after converting to aimpos format ), then
	//at destination it will be added 
	/*Credits: reVC
	target += Cams[ActiveCam].Up * Tan(angleY);
		target += CrossProduct(Cams[ActiveCam].Front, Cams[ActiveCam].Up) * Tan(angleX);
		target.Normalise();
		source += DotProduct(pos - source, target)*target;
		target = dist*target + source;
		*/
	//target is camera_front.
	//So
		local target = camera_front;
		local angleY=0.109956;
		local angleX= 0.058643;
		target -= camera_up * tan( angleY );
		local c = CrossProduct( camera_front, camera_up );
		c= Vector( c.x *  tan(angleX), c.y *  tan(angleX), c.z * tan(angleX) );
		target-= c;
		
		//Now find the alpha and angle of this target.
		local nalpha= atan2( target.z-p.z, sqrt( pow( p.x-target.x,2)+pow(p.y-target.y,2) ) );
		local nangle= atan2( -(target.x), target.y );
		
		print(" new alpha is "+nalpha+ " and new angle is "+nangle );
		local aimDir = ToAimDir( nalpha, nangle );
		print("aimDir is "+ aimDir );
		return aimDir;
		
}
function ToAimDir( alpha, angle )
{
	local aimz, aimx=0.0, aimy;
	//print("angle is "+angle+" and alpha is "+alpha+"\n");
	if( abs(angle)< PI/2 )
	{
		aimz = angle;
		if( alpha > 0 )
			aimy = -PI + alpha;
		else	
			aimy = PI + alpha
	}else 
	{
		aimx = PI;
		if( angle > 0 )
		{
			aimz = PI - angle;
			 
		}else
			aimz = -PI - angle;
		aimy = alpha;
	}
	local aimDir = Vector(aimx, aimy, aimz );
	return aimDir;
}
function CrossProduct(a,b)
{
	local c = Vector(a.y*b.z-b.y*a.z, -(a.x*b.z-b.x*a.z), a.x*b.y-b.x*a.y);
	return c;
}
		
	
	
