function onScriptLoad()
{
	a_Actors<-[];
	mission_status <- false;
	names<-["__", "_^", "_*", "_!", "^*", "^!", "*!", "_t", "_q", "_r", "_s", "_u"];
	dofile("scripts/managebots.nut");
	LoadClassData();
	//ConnectActors();
	SetShowNametags( false );
	SetJoinMessages( false );
	SetDeathMessages( false );
	
	//To view npcs mutiple window, uncomment the following line
	//ShowNPCConsole();
}
class Actor
{
	Pos = Vector(0.0, 0.0, 0.0) ;
	Angle = 0.0;
	constructor( x, y, z , f_angle )
	{
		Pos = Vector( x, y, z );
		Angle = f_angle;
	}
}
function LoadClassData()
{
	a_Actors.push( Actor( -1110.52, 68.0874, 11.263, -1.45395 ) ) ;
	a_Actors.push( Actor( -1110.58, 74.338, 11.263, -2.11012 ) ) ;
	a_Actors.push( Actor( -1107.69, 97.9161, 11.263, -3.11086 ) ) ;
	a_Actors.push( Actor( -1114.45, 62.4275, 11.1711, 0.14295 ) ) ;
	a_Actors.push( Actor( -1129.53, 86.7997, 11.1269, -2.43283 ) ) ;
	a_Actors.push( Actor( -1140.51, 64.3318, 11.1277, -0.15829 ) ) ;
	a_Actors.push( Actor( -1174.26, 66.8537, 11.128, 0.0551281 ) ) ;
	a_Actors.push( Actor( -1187.55, 101.171, 11.1281, 3.05161 ) ) ;
	a_Actors.push( Actor( -1188.42, 69.6063, 14.5819, 0.240934 ) ) ;
	a_Actors.push( Actor( -1187.76, 67.4704, 17.9584, 0.098464 ) ) ;
	a_Actors.push( Actor( -1197.57, 97.3469, 11.1281, -1.55903 ) ) ;
	//  Snipper on roof 
	a_Actors.push( Actor( -1174.93, 70.7562, 23.9366, -1.57379 ) ) ;
}
function ConnectActors()
{
	local i;
	//Connect NPC's one by one with a 100 ms delay.
	for( i = 0; i < a_Actors.len()  ; i++ )
	{
		NewTimer("ConnectNPCEx", i*100 + 1, 1,  names[i], a_Actors[i].Pos.x, 
		a_Actors[i].Pos.y, a_Actors[i].Pos.z, a_Actors[i].Angle, 
		85+(i%2), i!=11?27:29, 1, "attack_script.nut"  //skin, weapon,  script
		,"",i!=11?"Ruger":"Sniper");
	}
}
function test()
{
	local i;
	//Connect NPC's one by one with a 100 ms delay.
	for( i = 0; i < a_Actors.len()  ; i++ )
	{
		local t = format("npcclient64 -m npcscripts/attack_script.nut -n %s -a \"x%f y%f z%f a%f s%d w%d",
		names[i], a_Actors[i].Pos.x, 
		a_Actors[i].Pos.y, a_Actors[i].Pos.z, a_Actors[i].Angle, 
		85+(i%2), i!=11?27:29);
		print(t);
	}
}


function onPlayerCommand(player,cmd,text)
{
	
	if(cmd=="SYNCSHOTS")
	{
		if(IsPlayerNPC(player.ID))
			ManageMailingList(player.ID, ADD_TO_MAILING_LIST);
	}else if(cmd=="PLOS")
	{
		if(IsPlayerNPC(player.ID) && text)
		{
			local idx=[0];
			local playerid = strtok(text, idx); 
			local x = strtok(text, idx);
			local y = strtok(text, idx);
			local z = strtok(text, idx);
			local dx = strtok(text, idx);
			local dy = strtok(text, idx);
			local dz = strtok(text, idx);
			local flags = strtok(text, idx);
			local weapon = strtok(text,idx);
			try{
				playerid = playerid.tointeger();
				x = x.tofloat();
				y = y.tofloat();
				z = z.tofloat();
				dx = dx.tofloat();
				dy = dy.tofloat();
				dz = dz.tofloat();
				flags= flags.tointeger();
				weapon = weapon.tointeger();
				local plr = FindPlayer( playerid );
				if( plr )
				{
					local start = Vector( x, y, z );
					local j = 1.0; //1 meter from aim pos, otherwise RayTrace gives shooter itself 
					start += Vector( j*dx, j*dy, j*dz );
					local k = GetWeaponDataValue( weapon, 2 );
					local end = start + Vector( k * dx, k * dy, k * dz );
					/*local output=format("ProcessLineOfSight( FindPlayer(%d), Vector(%f,%f,%f), Vector(%f,%f,%f), %d, %d )", 
					playerid, x, y, z, end.x, end.y, end.z, flags, weapon );
					//print(output);*/
					ProcessLineOfSight( plr, start, end , flags, weapon, player.ID );
					//Done. 
				}
			}catch(e)
			{
				print("Error: "+e);
			}
		}
		
	}else if(cmd== "NPC_COMMU")
	{
		if(IsPlayerNPC( player.ID ) && text )
		{
			for(local i=0; i< GetMaxPlayers(), i!=player.ID ; i++ )
			{
				if( FindPlayer(i ) && IsPlayerNPC( i ) )
				{
					ClientMessage( text, FindPlayer(i), 15, 15, 15 );
				}
			}
		}
	}else if(cmd=="startmission")
	{
		if(!mission_status)
		{
			if(player.IsSpawned)
			{
				StartMission();
			}else MessagePlayer("You have to spawn first", player);
		}else MessagePlayer("The mission is already started", player );
	}else if(cmd == "cmds" )
	{
		PrivMessage(player, "No commands available now");
		PrivMessage(player, "/startmission");
	}else MessagePlayer("Unknown command. Try /cmds",player);
}

function onPlayerRequestClass( player, classID, team, skin )
{
	if(!IsPlayerNPC( player.ID ) && classID!=0 )
	{
		Announce("Please select 'cuban' skin", player, 0);
		return 0;
	}else return 1;
}

function onPlayerRequestSpawn(player){

	if( IsPlayerNPC( player.ID ) ==false )
	{
		if( player.Class == 1)
		{
			Announce("Please select 'cuban' skin", player, 0);
			return 0;
		}
		if(!mission_status)
		StartMission();
	}
	return 1;
}
function onPlayerSpawn(player){
	if( IsPlayerNPC( player.ID ) )
	{
		//player.Pos = a_Actors[n_actors].Pos;
		//player.Angle = a_Actors[n_actors].Angle;
		/*ClientMessage("SetTimerEx( \"SetMyFacingAngle\", 1000, 1, "+a_Actors[n_actors].Angle+" )", player,
		0x0c, 0x0c, 0x0c );//See SERVER.COMPILE_SCRIPT*/
		//Setting angle won't work because player is joining after npcs.
		//player.Skin = 85 + ( n_actors % 2 ); 
		//player.Team = 2;
	}else 
	{
		/*if( !mission_status )
		StartMission();*/
	}
}
function strtok(string,array)
{
	 local index=array[0];
	 local length=string.len();
	 /* Skip the leading white space */
	 while(index<length && string[index]<=' ')
	  index++;
	 local result="";
	 local offset = index;
	 while( index < length && string[index] > ' ' && index-offset < 20-1)
	 {
	  result+=string.slice(index,index+1);
	  index++;
	 }
	 array[0]=index;
 return result;
}
function onConsoleInput(cmd, arg)
{	
		try
		{
			local script = compilestring( cmd );
			script();
		}
		catch(e) print( "Error: " + e );	
}
function IsAllNPCDead()
{
	for( local i =0 ; i< GetMaxPlayers(); i++)
	{
		if(FindPlayer( i ) && IsPlayerNPC( i ) && FindPlayer(i).Health>0)
		return false;
	}
	return true;
}
function onPlayerDeath(player,reason){
	if( IsPlayerNPC( player.ID) && IsAllNPCDead() ) 
	{
		//AnnounceAll("Test mission with npc completed.", 0 );
		AnnounceAll("passed", 3 );
		EndMission();
	}
}
function onPlayerKill( killer, player, reason, bodypart )
{
	if( IsPlayerNPC( player.ID) && IsAllNPCDead() ) 
	{
		//AnnounceAll("Test mission with npc completed. Thanks everyone", 0 );
		AnnounceAll("passed", 3 );
		EndMission();
	}
	if( IsPlayerNPC( player.ID )==false )
	AnnounceAll(player.Name+" is dead "+ GetWeaponName( reason )+" "+GetBodyPartName(bodypart), 0);
}
function GetBodyPartName( bodypart )
{
	switch( bodypart )
	{
		//default:
		case BODYPART_BODY: return "Body";

		case BODYPART_TORSO: return "Torso";

		case BODYPART_LEFTARM: return "Left Arm";

		case BODYPART_RIGHTARM: return "Right Arm";

		case BODYPART_LEFTLEG: return "Left Leg"; 

		case BODYPART_RIGHTLEG: return "Right Leg";

		case BODYPART_HEAD: return "Head";
		default: return "Body";
	}
}
function EndMission()
{
	for( local i =0 ; i<GetMaxPlayers(); i++)
	{
		if(FindPlayer(i) && IsPlayerNPC( i ) )
		{
			KickPlayer( FindPlayer(i ) );
		}
	}
	mission_status=false;
	print("Mission ended");
}
function StartMission()
{
	if(mission_status)return;
	print("Mission starting..");
	ConnectActors();
	mission_status = true;
}
function onPlayerJoin( player )
{
	if(!IsPlayerNPC( player.ID ) )
	{
		AnnounceAll("Player "+ player.Name+ " has joined the server");
	}
}
